<?php
include_once "includes/customfuncs_site.php";
//funcion decriptar_passwords - ver. 1   
//Devuelve un string decriptado que se haba encriptado con la funcin equivalente. debe tener un string que se llama key_crypt definido en globals   
function encriptar_passwords($string) {
	global $key_crypt;
   	$encrypted = base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_256, md5($key_crypt), $string, MCRYPT_MODE_CBC, md5(md5($key_crypt))));
  	return $encrypted;
}
function decriptar_passwords($string) {
	global $key_crypt;
  $decrypted = rtrim(mcrypt_decrypt(MCRYPT_RIJNDAEL_256, md5($key_crypt), base64_decode($string), MCRYPT_MODE_CBC, md5(md5($key_crypt))), "\0");
  return $decrypted;
}
//verifica si existe nuevo PHP5, de no tenerlo usa metodo viejo. 
if(!function_exists("mysqli_query")){	
	function mysqli_fetch_array($result){
		return mysql_fetch_array($result);
	}
	function mysqli_num_rows($result){
		return mysql_num_rows($result);
	}
	function mysqli_fetch_row($result){
		return mysql_fetch_row($result);	
	}
	function mysqli_data_seek($result, $row){
		return mysql_data_seek($result, $row-1);
	}
	function mysqli_select_db($conn, $db_name){
		return mysql_select_db ($db_name);//solo funciona con la conexion actual
	}
	class mysqli{
		var $conn_slqi;
		function __construct($DB_SERVER, $DB_USER, $DB_PASS){
			global $conn_sqli;
			$conn_sqli = mysql_connect($DB_SERVER, $DB_USER, $DB_PASS);
		}
		function query($q){
			global $conn_sqli;
			return mysql_query($q,$conn_sqli);
		}		
	}
}
//reemplaza mysql_result viejo
function db_result($result,$field) { 
  if(mysqli_num_rows($result)==0) {
	  return false; 
  }
  mysqli_data_seek($result, 1);
  $ceva=mysqli_fetch_array($result); 
  $rasp=$ceva[$field]; 
  return $rasp; 
}
//Hace un md5 hash con salt
function md5_salt($string, $tipo_user = 'interno'){ 
	global $salt, $salt2;
	if($tipo_user == 'interno'){
		$salt_local = $salt;
	}elseif($tipo_user = 'externo'){
		$salt_local = $salt2;
	}
    // Create a salt 
    $salted = md5($string.$salt_local); 
    // Hash the string 
    $string = md5($salted.$string.$salted);     
    return $string; 
}
//Mata la pagina, pero incluye primero el mensaje y el bottom de la pagina
function pretty_die($mensaje = ''){
	global $bottom_txt;
	if($mensaje != ''){
		echo $mensaje;
	}
	include_once "bottom.php";
	die();
}
//Convierte la fecha en timestamp, formato (dd/mm/yyyy)
function ts_fecha($fecha, $inicio_del_dia = true){
	if(strstr($fecha, "/")){
		$fecha_inicial_exp = explode("/", $fecha);
		if($inicio_del_dia){
			return mktime(0, 0, 0, $fecha_inicial_exp[1], $fecha_inicial_exp[0], $fecha_inicial_exp[2]);
		}else{
			return mktime(23, 59, 59, $fecha_inicial_exp[1], $fecha_inicial_exp[0], $fecha_inicial_exp[2]);
		}
	}else{
		return 0;
	}
	
}
// Toma un array y le elimina los campos que se entreguen en la variable $remove separados por -*-, luego los pone en una cadena de get. (se utiliza para guardar filtros en la paginacion)
function remarraysendtoget($array, $remove, $inicio = false){
	$result = "";
	$removes = explode("-*-", $remove);
	$removes = array_flip($removes);
	
	$limpiador = array("noopcion", "");
	$arraylimpio = array_diff($array, $limpiador);
	$output = array_diff_key($arraylimpio, $removes);
	//var_dump($output);
	foreach($output as $key => $v){
		if(!preg_match("/[^A-Za-z0-9_.@-]/", $v)){
			if ($inicio){
				$result .= "?";
				$inicio = false;
			}else{
				$result .= "&";
			}
			$result .= filter_var($key, FILTER_SANITIZE_SPECIAL_CHARS)."=".ref_to_get(limpiar_input($key, 'get', 'string'));
		}
	}
	return $result;
}
//*****************************************
//Funcin limpiar_input v1.0
//Limpia un input enviado por el cliente.
//*****************************************
//$string_name: variable que se va a limpiar
//$metodo = 'post': el metodo POST o GET.
//$tipo = 'string': tipo de variable int, string, text, float
//$strict = false : devuelve la variable con solo numeros o letras
function limpiar_input($string_name, $metodo = 'post',  $tipo = 'string', $strict = false){
	if($tipo == 'string'){
		if($metodo == 'post'){
			if(isset($_POST[$string_name])){
				$var = trim(filter_var($_POST[$string_name], FILTER_SANITIZE_STRING));
			}else{
				return false;
			}
		}elseif($metodo == 'get'){
			if(isset($_GET[$string_name])){
				$var = trim(filter_var($_GET[$string_name], FILTER_SANITIZE_STRING));
			}else{
				return false;
			}
		}else{
			return false;
		}
	}elseif($tipo == 'int'){
		if($metodo == 'post'){
			if(isset($_POST[$string_name])){
				$var = intval(filter_var($_POST[$string_name], FILTER_SANITIZE_STRING));
			}else{
				return false;
			}
		}elseif($metodo == 'get'){
			if(isset($_GET[$string_name])){
				$var = intval(filter_var($_GET[$string_name], FILTER_SANITIZE_STRING));
			}else{
				return false;
			}
		}else{
			return false;
		}
	}elseif($tipo == 'text'){
		if($metodo == 'post'){
			if(isset($_POST[$string_name])){
				$var = trim($_POST[$string_name]);
			}else{
				return false;
			}
		}elseif($metodo == 'get'){
			if(isset($_GET[$string_name])){
				$var = trim($_GET[$string_name]);
			}else{
				return false;
			}
		}else{
			return false;
		}
	}elseif($tipo == 'float'){
		if($metodo == 'post'){
			if(isset($_POST[$string_name])){
				$var = (float)(filter_var($_POST[$string_name], FILTER_SANITIZE_STRING));
			}else{
				return false;
			}
		}elseif($metodo == 'get'){
			if(isset($_GET[$string_name])){
				$var = (float)(filter_var($_GET[$string_name], FILTER_SANITIZE_STRING));
			}else{
				return false;
			}
		}else{
			return false;
		}
	}else{
		return false;
	}
	if($strict){
		$var = preg_replace("/[^A-Za-z0-9_]/", "", $var);
	}
	return $var;
}
//Devuelve true si tiene permiso 
function tiene_permiso($pregunta, $userid){
	global $DB_USERS_PERMISOS, $mysql;
	if($userid == ''){
		return false;
	}
	if($userid == 1 or $pregunta == 'all'){ 
		return true;
	}
	$q = "SELECT COUNT(*) FROM ".$DB_USERS_PERMISOS." WHERE id_user = ".$userid." AND id_permiso = ".$pregunta;
	//echo $q;
	$result = $mysql->query($q);
	$cant = db_result($result, 0);
	if($cant == 1){
		return true;
	}else{ 
		return false;
	}
}
//La funcion cambia el permiso de un usuario
function cambiar_permiso_user($userid, $id_permiso, $tiene_permiso){
	global $DB_USERS_PERMISOS, $mysql;
	$q = "SELECT COUNT(*) FROM ".$DB_USERS_PERMISOS." WHERE id_user = ".$userid." AND id_permiso = ".$id_permiso;
	$result = $mysql->query($q);
	$cant = db_result($result, 0);
	$q_final = "";
	if($cant == 1){
		if(!$tiene_permiso){
			$q_final = "DELETE FROM ".$DB_USERS_PERMISOS." WHERE id_user = ".$userid." AND id_permiso = ".$id_permiso;
		}
	}else{
		if($tiene_permiso){
			$q_final = "INSERT INTO ".$DB_USERS_PERMISOS." (id_user, id_permiso) VALUES (".$userid.", ".$id_permiso.")";
		}
	}
	if($q_final != ''){
		return $mysql->query($q_final);
	}else{
		return true;
	}
}
//Devuelve el nombre de un item en una table especifica 
function nombre_tabla($id, $tabla, $campo = 'descripcion', $nombre_variable = 'id'){
	global $nodisponible, $mysql;
	if($id != '' or $id != NULL){
		$q = "SELECT * FROM ".$tabla." WHERE ".$nombre_variable." = ".$id;
		//echo $q;
		$results = mysqli_fetch_array($mysql->query($q));
		return htmlentities($results[$campo]);	
	}else{
		return $nodisponible;
	}
}
//Devuelve el ultimo id que se inserto en una tabla con auto incremento.
function last_inserted_id(){
	global $mysql;
	$result = mysqli_fetch_row($mysql->query("SELECT LAST_INSERT_ID()"));
	return $result[0];
}
//Funcion para php < 5
if (!function_exists('array_diff_key')){   
	function array_diff_key()    {        
		$arrs = func_get_args();        
		$result = array_shift($arrs);        
		foreach ($arrs as $array) {            
			foreach ($result as $key => $v) {                
				if (array_key_exists($key, $array)) {                    
					unset($result[$key]);                
				}            
			}        
		}        
	return $result;   
	}
}
//la funcion valida un correo. devuelve true o false
function valid_mail($mail){
    return filter_var($mail, FILTER_VALIDATE_EMAIL) && preg_match('/@.+\./', $mail);
}
//Verifica si el numero de telefono entregado es valido
function valid_tel($tel, $largo){
	$largo2 = 4;
	$largo1 = $largo - $largo2;
	if (!stristr($tel,'-')){
		$tel = substr($tel, 0, $largo1)."-".substr($tel, $largo1, $largo2);
	}
	if (!preg_match('/^[0-9]{'.$largo1.'}-[0-9]{'.$largo2.'}$/', $tel)) {
		return false;
	}else{
		return $tel;
	}
}
//Devuelve un telefono con formato
function format_tel($telefono){
	$con_formato = substr($telefono, 0, -4)."-".substr($telefono, -4);
	return $con_formato;
}
//Verifica en la base de datos si el nombre de usuario existe.
function user_existe($nombre, $id_mod = NULL){
	global $DB_USERS, $mysql;
	$q = "SELECT COUNT(*) FROM ".$DB_USERS." WHERE user LIKE '".$nombre."'";
		if($id_mod != NULL){
			$q .= " AND id != ".$id_mod;
		}
	if($result = $mysql->query($q)){
		$cant = db_result($result, 0); 
		if($cant == 0){
			return false;
		}else{
			return true;
		}
	}else{
		return false;
	}
}
//Crea el titulo de una tabla ordenadora - el display es el texto que se ve a mostrar en el top de la tabla, la variable es a la variable que responde, o sea la variable que ordena, orderby es por la variable q se esta ordenando la pagina en el momento y ordendir es la direccion que se esta ordenando ( ASC o DESC). y $pagina es la pagina que se esta utilizando p.ej. productos.php, $otros son variables adicionales que se pueden utilizar en el Get para poder guardar los filtros q se estan mostrando.
function creartituloordenador($display, $variable, $orderby, $orderdir, $pagina, $otros){
	$response = "<a href='".$pagina;
	$display_out = $display;
	$selected = false;
	if ($variable != $orderby){
		$orderdir =  "ASC";
	}elseif($orderdir == "ASC"){
		$selected = true;
		$orderdir = "DESC";
		$display_out .= " <img src='images/sistema/flecha_down.gif' border='0' />";
	}else{
		$selected = true;
		$orderdir = "ASC";
		$display_out .= " <img src='images/sistema/flecha_up.gif' border='0' />";
	}
	$response .= "?orderby=".$variable."&orderdir=".$orderdir."".$otros."'";
	if($selected){$response .= "class='toptableselected' ";}
	$response .= ">".$display_out."</a>";
	return $response;
}
// Crea las opciones de un campo select, las variables que se dan son el query ya hecho, el objeto seleccionado, el campo del valor ( o sea en la tabla como se llama el campo del valor en el select) y el campo del nombre (en la tabla) si no se tiene nada seleccionado apararece un texto, seleccione uno.
//la variable limpiear, la quinta, es booleana, true, si desea poner una opcion, que se pueda limpiar la seleccion (opcion todos).
function createselectitems($query, $selected, $campovalor, $camponombre, $limpiar = false, $idioma = "es"){
	global $seleccione_txt, $limpiar_txt;
	$output = "";
	if($selected == '' or $selected == 'noopcion' or ($selected == 0 and is_numeric($selected))){
		$output .= $output."<option value='noopcion' selected='selected'>".$seleccione_txt[$idioma]."</option>";
	}elseif($limpiar){
		$output .= "<option value='noopcion'>".$limpiar_txt[$idioma]."</option>";
	}
	while ($array = mysqli_fetch_array($query)){
		$output .= "<option value='".$array[$campovalor]."'";
		if ($selected == $array[$campovalor]){
			$output .= " selected='selected' >";		
		}else {
			$output .= " >";
		}
		$output .= "".$array[$camponombre]."</option>";
	}
	return $output;
}
// Crea las opciones de un campo select, las variables que se dan son el array ya hecho, el objeto seleccionado, EL ARRAY DEBE VENIR EN EL FORMATO (la llave sera el valor del select y el valor en el array ser el display en el select). Si no se tiene nada seleccionado apararece un texto, seleccione uno.
function createselectitems_array($array, $selected, $limpiar = false, $idioma = 'es'){
	global $seleccione_txt, $limpiar_txt;
	$output = "";
	if($selected == '' or $selected == 'noopcion' or $selected == 'NULL'){
		$output .= "<option value='noopcion' selected='selected'>".$seleccione_txt[$idioma]."</option>";
	}elseif($limpiar){
		$output .= "<option value='noopcion'>".$limpiar_txt[$idioma]."</option>";
	}
	foreach($array as $key => $value) {
		$output = $output."<option value='".$key."'";
		if ($selected == $key){
			$output = $output." selected='selected'>";		
		}else {
			$output = $output.">";
		}
		$output = $output.$value."</option>";
	}
	return $output;
}
//Devuelve true si la pagina que se compara es el script que se est ejecutando y false de cualquier otra manera.
function is_script($page){
	$script = explode("/",$_SERVER['SCRIPT_NAME']);
	if (end($script) == $page){
		return true;
	}else{
		return false;
	}
}
//Redirige automaticamente a la pagina que se envia, es null se regresa a index.php
function redirect($dir = NULL){
	if($dir == NULL){
		$dir = "index.php";
	}
	header('Location: '.$dir);
}
//Devuelve todos los datos del usuario
function userdata($id){
	global $DB_USERS, $mysql;		
	$struser = "SELECT * FROM ".$DB_USERS." WHERE id = ".$id; 
	$result = $mysql->query($struser);
	return mysqli_fetch_array($result);
} 
//Devuelve solamente el nombre de usuario
function nombreusuario($id, $solonombre = false){
	$datos = userdata($id);
	$result = $datos['nombre'];
	if(!$solonombre){
		$result .= " ".$datos['apellido'];
	}
	return $result;
}
//cambia el class del background color para las lineas intercaladas.
function switchbgcolor($actual){
	if($actual == ''){
		$result = "bgcolor1";
	}else{
		if($actual == 'bgcolor1'){
			$result = 'bgcolor2';
		}elseif($actual == 'bgcolor2'){
			$result = 'bgcolor1';
		}
	}
return $result;
}
//Crea la tabla con las paginas adicionales.
function paging($pagina, $pagactual, $cantpaginas, $otros, $enadmin = false, $pagina_text = 'P&aacute;gina', $de_of = 'de'){
$result = '';
$cant_tabla_pages = 11;
if ($cantpaginas > 1){
$result .= '
<div class="page_center"><div class="page_right"><div class="page_left">
<table border="0" cellspacing="0" cellpadding="0" align="center" class="paginacion">
  <tr>
    <td align="center" width="25">';
	if ($pagactual > 1){
		$page = $pagactual - 1;
		$result .='<a href="'.$pagina.'?page='.$page.$otros.'">&lt;</a>';
	}else {
		$result .= '&nbsp;';
	}
	$result .='</td>
    <td align="center"><table width="100%" border="0" cellspacing="0" cellpadding="0"><tr>';
	if($pagactual <= 6){
		$cont = 1;	
	}else{
		$cont = $pagactual - 5;
		if($pagactual + 5 >= $cantpaginas){
			$cont = $cantpaginas - $cant_tabla_pages +1;
		}
	}
	$control = true;//mientras sea true sigue mostrando las paginas
	while($cont <= $cantpaginas){
		if ($cont == $pagactual){
			$result .= '<td>'.$cont .'</td>';
		}else {
			if($control){
				$result .= '<td><a href="'.$pagina.'?page='.$cont.$otros.'">'.$cont.'</a></td>';
			}
		}
		if($cont >= $pagactual + 5){
			$control = false;
		}
		if($pagactual <= 6 and $cont < $cant_tabla_pages){
			$control = true;
		}
		if ($cont != $cantpaginas and $control){
			$result .= '<td> - </td>';
		}
		$cont++;
	}
	$result .= '</tr></table></td>
    <td align="center" width="25">';
	if ($pagactual < $cantpaginas){
		$page = $pagactual + 1;
		$result .='<a href="'.$pagina.'?page='.$page.$otros.'">&gt;</a>';
	}else{
		$result .= '&nbsp;';
	}
	$result .='
	</td>
  </tr>
  <tr>
    <td colspan="3" align="center" class="texto_paginacion">'.$pagina_text.' '.$pagactual.' '.$de_of.' '.$cantpaginas.'</td>
  </tr>
</table></div></div></div>';
}elseif($enadmin){
	$result .= '<img src="images/bot_home.gif" alt="-" />';
}else{
	$result = '<span class="paginacion">No hay m&aacute;s p&aacute;ginas</span>';
	$result = '&nbsp;';
}
return $result;
}
//Devuelve la fecha formateada cuando se le entrega una fecha en timestamp
function format_fecha($fecha){
	return date("d/m/Y", $fecha);
}
//Devuelve la el numero formateado como dinero
function format_dinero($numero){
	$numero_con_dec = number_format($numero, 2);
	$numero_exp = explode(".", $numero_con_dec);
	return "B/. ".$numero_exp[0].".<sup>".$numero_exp[1]."</sup>";
}
//Devuelve e imprime el boton de regresar con el script de javascript
function back_button($dir = "back.php"){
	$html = '';
	$html .= '  <div class="main regresar"><a href="'.$dir.'">Regresar</a></div>';
	echo $html;
}
//Sendmail, manda correo mediante phpmailer.
//la variable para es un array, el 0 es el mail y el 1 es el nombre
//Version attachment
function sendmail($de, $para, $subject, $message, $htmlmessage = true, $attachment = false){
	global $upload_dir;
	require_once('includes/mailer/class.phpmailer.php');
	$mailer = new PHPMailer();
	$mailer->isHTML($htmlmessage);
	$mailer->Priority = 3;
	$mailer->From = $de[0]; 
	$mailer->FromName = $de[1];
	$mailer->Subject = $subject; 
	$mailer->Body = $message; 
	$mailer->AddAddress($para[0], $para[1]);
	if($attachment){
		$nombre_exp = explode('.', $attachment);
		$ext = $nombre_exp[count($nombre_exp)-1];
		switch($ext){
			case 'pdf':
				$type = "application/pdf";
				break;
			case 'doc':
				$type = 'application/msword';
				break;
			case 'docx':
				$type = 'application/vnd.openxmlformats-officedocument.wordprocessingml.document';
				break;
			default:
				$type = '';
				break;
		}
		$mailer->AddAttachment($upload_dir.$attachment, $attachment, "base64", $type);
	}
	if(!$mailer->Send()) 
	{ 
	  $send_error=true; 
	  return false;
	} 
	else 
	{ 
	  $send_error=false; 
	  return true;
	}
	$mailer->ClearAddresses(); 
	$mailer->ClearAttachments(); 
}
//la funcion cambia los caracteres que puedan confundirse en el url por sus equivalentes en ascii
function ref_to_get($ref){
	$result = str_replace("&", "%26", $ref);
	$result = str_replace("?", "%3F", $result);
	return $result;
}
//la funcion cambia a caracteres que puedieron confundirse en el url de sus equivalentes en ascii
function get_to_ref($ref){
	$result = str_replace("%26", "&", $ref);
	$result = str_replace("%3F", "?", $result);
	return $ref;
}
//Graba una entrada de la bitacora.
function agregarbitacora($modulo, $descripcion){
	global $DB_HUELLAS, $mysql;
	$q = "INSERT INTO ".$DB_HUELLAS." (id, userid, ip, fecha, modulo, cambio)VALUES ('', '".$_SESSION['userid']."', '".$_SERVER['REMOTE_ADDR']."', '".time()."', '".$modulo."', '".$descripcion."')";
	if($mysql->query($q)){
		return true;
	}else{
		return false;
	}
}
//Genera un password Aleatorio
function createPassword($length) {
	$chars = "abcdefghijkmnopqrstuvwxyz1234567890";
	$i = 1;
	$password = "";
	while ($i <= $length) {
		$password .= $chars{mt_rand(0,strlen($chars)-1)};
		$i++;
	}
	return $password;
}
//convierte un color en hexagesimal a un array RGB
function hex2rgb($hex) {
   $hex = str_replace("#", "", $hex);

   if(strlen($hex) == 3) {
      $r = hexdec(substr($hex,0,1).substr($hex,0,1));
      $g = hexdec(substr($hex,1,1).substr($hex,1,1));
      $b = hexdec(substr($hex,2,1).substr($hex,2,1));
   } else {
      $r = hexdec(substr($hex,0,2));
      $g = hexdec(substr($hex,2,2));
      $b = hexdec(substr($hex,4,2));
   }
   $rgb = array($r, $g, $b);
   //return implode(",", $rgb); // returns the rgb values separated by commas
   return $rgb; // returns an array with the rgb values
}
function create_low_res($imagen_inicial, $imagen_final, $nw, $nh, $watermark_name = NULL, $tamanos_fijos = true, $fondo_relleno = NULL){
	if($watermark_name != ''){
		//marca de agua
		$watermark = imagecreatefromjpeg($watermark_name);
		$size_watermark = getimagesize($watermark_name);
		$h_watermark = $size_watermark[1];
	}
	if($fondo_relleno != NULL){
		$color_fondo =hex2rgb($fondo_relleno); 
	}
	$source = $imagen_inicial;
	$is_jpg = false;
	$is_gif = false;
	$is_png = false;
	if(strstr($source, '.jpg')){
		$simg = imagecreatefromjpeg($source);
		$is_jpg = true;
	}elseif(strstr($source, '.gif')){
		$simg = imagecreatefromgif($source);
		$is_gif = true;
	}elseif(strstr($source, '.png')){
		$simg = imagecreatefrompng($source);
		$is_png = true;
	}else{
		return false;
	}
    $size = getimagesize($source);
    $w = $size[0];
    $h = $size[1];
	
	//ratio de la imagen original
	$orata = $w / $h;
	//ratio de la imagen nueva
	$nrata = $nw / $nh;

    $dimg = imagecreatetruecolor($nw, $nh);
 
    $wm = $w/$nw;
    $hm = $h/$nh;
 
    $h_height = $nh/2;
    $w_height = $nw/2;
	if($tamanos_fijos){
		if($nrata > $orata) {
	 
			$adjusted_height = $h / $wm;
			$half_height = $adjusted_height / 2;
			$int_height = $half_height - $h_height;
	 
			imagecopyresampled($dimg,$simg,0,-$int_height,0,0,$nw,$adjusted_height,$w,$h);
			
	 
		} else {
			$adjusted_width = $w / $hm;
			$half_width = $adjusted_width / 2;
			$int_width = $half_width - $w_height;
	  
			imagecopyresampled($dimg,$simg,-$int_width,0,0,0,$adjusted_width,$nh,$w,$h);
		}
		if($watermark_name != ''){
			imagecopymerge($dimg, $watermark, 0, $nh-$h_watermark, 0, 0, $nw, $nh, 90); 
			imagedestroy($watermark);
		}
	}else{//Si no son tamanos fijos - o sea son tamanos maximos
		//ratio values
		$original_ratio = $w / $h;
		$new_ratio = $nw / $nh;
		 
		$widthm = $w/$nw;
		$heightm = $h/$nh;
		if($w > $nw or $h > $nh){//por si la imagen es mas grande que la que queremos...
			if($original_ratio > $new_ratio){
				//Si la imagen sobrepasa el width limite
				$h_actual = ceil($nw/$original_ratio);
				$dimg = imagecreatetruecolor($nw, $h_actual);  
				if($fondo_relleno != NULL){
					$dimg = imagecreatetruecolor($nw, $nh);
					$color = imagecolorallocate($dimg, $color_fondo[0], $color_fondo[1], $color_fondo[2]);
					imagefill($dimg, 0, 0, $color);	
					$calc_x = 0;
					$calc_y = ceil(($nh - $h_actual) / 2);				
				}else{
					$calc_x = 0;
					$calc_y = 0;
				}
				imagecopyresampled($dimg,$simg,$calc_x,$calc_y,0,0,$nw,$h_actual,$w,$h);
				if($watermark_name != ''){
					imagecopymerge($dimg, $watermark, 0, $h_actual-$h_watermark, 0, 0, $w, $h, 90);	
				}
			}else {
				//echo "height";
				//Si la imagen sobrepasa el height limite
				$w_actual = $original_ratio*$nh;
				/*$h_dif = 0;
				$w_dif = ($w_actual - $nw)/2; */
				$dimg = imagecreatetruecolor($w_actual, $nh);
				if($fondo_relleno != NULL){
					$dimg = imagecreatetruecolor($nw, $nh);
					$color = imagecolorallocate($dimg, $color_fondo[0], $color_fondo[1], $color_fondo[2]);
					imagefill($dimg, 0, 0, $color);	
					$calc_x = ceil(($nw - $w_actual) / 2);				
					$calc_y = 0;
				}else{
					$calc_x = 0;
					$calc_y = 0;
				}	
				imagecopyresampled($dimg,$simg,$calc_x,$calc_y,0,0,$w_actual,$nh,$w,$h);
				if($watermark_name != ''){
					imagecopymerge($dimg, $watermark, 0, $nh-$h_watermark, 0, 0, $w, $h, 90); 
				}
			}
			
		
		}else{
			//echo 'hola';
			//Si la imagen es menor que el ancho y alto limites
			if($fondo_relleno == NULL){
				$dimg = $simg;
			}else{				
				$dimg = imagecreatetruecolor($nw, $nh);
				$color = imagecolorallocate($dimg, $color_fondo[0], $color_fondo[1], $color_fondo[2]);
				imagefill($dimg, 0, 0, $color);	
				$calc_x = ceil(($nw - $w) / 2);				
				$calc_y = ceil(($nh - $h) / 2);
				imagecopyresampled($dimg,$simg,$calc_x,$calc_y,0,0,$w,$h,$w,$h);
			}
			if($watermark_name != ''){
				imagecopymerge($dimg, $watermark, 0, $h - $h_watermark, 0, 0, $w, $h, 90); 
			}
		}
	}
	if($is_jpg){
    	return (imagejpeg($dimg, $imagen_final, 90));
	}elseif($is_gif){
    	return (imagegif($dimg, $imagen_final));
	}elseif($is_png){
    	return (imagepng($dimg, $imagen_final, 1));
	}else{
		return false;
	}
	imagedestroy($dimg);
	return true;
}
//Modifica el orden de los items cuando se han eliminado para que esten completos los numeros de orden
function reordenar_items($tabla, $dependiente_id = '', $dependiente_nombre = '', $nombre_id_item = 'id'){
	global $mysql;
	$q = "SELECT * FROM ".$tabla;
	if($dependiente_id != '' and $dependiente_nombre != ''){
		$q .= " WHERE ".$dependiente_nombre." = ".$dependiente_id;
	}
	$q .= " ORDER BY orden ASC";
	echo $q;
	$result = $mysql->query($q);
	$cont = 1;
	while($array = mysqli_fetch_array($result)){
		$q_upd = "UPDATE ".$tabla." SET orden = ".$cont." WHERE ".$nombre_id_item." = ".$array[$nombre_id_item];
		$result2 = $mysql->query($q_upd);
		$cont++;
	}
	return true;
}
//verificaciones de los password
function verifica_pw($pw){
	global $error, $caracteres_error;
	$error = '';
	if (strlen($pw) < $caracteres_error){
		$error = error('login2');
	} 
	elseif (!preg_match('`[0-9]`', $pw)){
    	$error = error('login4');
	}
	elseif (!preg_match('`[A-Z]`', $pw)){
      	$error = error('login5');
 	}
	elseif (!preg_match('`[a-z]`', $pw)){
    	$error = error('login6');
   	}
	return $error;
}
?>