<?php 
include_once "includes/auth.php";
if (!is_script($script)){
	die($no_ejecuta);
}
?>
<?php
//Se inicializan las variables
$inserted = false;
$error = "";

if($act == 'mod'){
	if(isset($_GET['id'])){
		$id = limpiar_input('id', 'get', 'int');
	}else{
		pretty_die("Debe escoger un cliente para modificar.");
	}
	$strdatos = "SELECT * FROM ".$DB_USUARIO." WHERE id = ".$id;
	$datos = mysqli_fetch_array($mysql->query($strdatos));
	$email = $datos['email'];
	$nombre = $datos['nombre'];
	$cod_magic = $datos['cod_magic'];
	$status = $datos['status'];
	$empresa = $datos['compania'];
	$ruc = $datos['ruc'];
}elseif($act == 'add'){
	$nombre = '';
	$empresa = '';
	$ruc = '';
	$email = '';
	$status = 1;
}
//error Checking
if ($_POST){
	$nombre = limpiar_input('nombre', 'post', 'string');
	$email = limpiar_input('email', 'post', 'string');	
	$cod_magic = limpiar_input('cod_magic', 'post', 'int');	
	$status = limpiar_input('status', 'post', 'int');
	$ruc = limpiar_input('ruc', 'post', 'string');
	$empresa = limpiar_input('empresa', 'post', 'string');
	
	//codigo de magic
	if($cod_magic != 0){
		$status = 1;	
	}
	//CODIGO MAGIC
	if($cod_magic == 0){
		$error = error('v2', 'Codigo de Magic');
	}
	//EMAIL
	if($act == 'add'){
		if($email == ''){
			$error = error('v1', 'user');
		}elseif(!valid_mail($email)){
			$error = error('v4');
		}elseif(mail_existe($email)){
			$error = error('v8');
		}
	}else{
		if($email == ''){
			$error = error('v1', 'user');
		}
	}
	//RUC
	if($ruc == ''){
		$error = error('v1', 'Ruc');
	}
	//EMPRESA
	if($empresa == ''){
		$error = error('v1', 'empresa');
	}
	//NOMBRE
	if($nombre == ''){
		$error = error('v1', 'Nombre');
	}
	if($error == ''){
		if($act == 'add'){
			$pass = createPassword(5);
			$q = "INSERT INTO ".$DB_USUARIO." (id, nombre, compania, ruc, representante_legal, cedula, gerente, telefono, contacto1, contacto2, contacto3, fax, celular, direccion, experiencia, email, compra_estimada, negocio, cod_magic, password, password_inicial, cambiarpassword, status) VALUES ('', '".$nombre."', '".$empresa."', '".$ruc."', '', '', '', '', '', '', '', '', '', '', '', '".$email."', '', '', ".$cod_magic.", '".md5_salt($pass)."', '".$pass."', 1, ".$status.")";	
			$cambio = "Se cre el usuario <strong>".$nombre."</strong> con email <strong>".$email."</strong>";
		}elseif($act == 'mod'){
			$q = "UPDATE ".$DB_USUARIO." SET nombre = '".$nombre."', email = '".$email."', cod_magic = '".$cod_magic."', status = '".$status."' WHERE id = ".$id;
			$cambio = "Se modific el usuario <strong>".$nombre."</strong> con email <strong>".$email."</strong>";
		}
		//echo $q;
		if($mysql->query($q)){
			agregarbitacora($main_modulo, $cambio);
			if($act == 'add'){
				$inserted = true;
			}else{
				redirect("back.php");
			}			
		}else{
			$error = error('db1')." ".$q;
		}
	}
}
?>
<?php 
	include_once "includes/top.php";
	echo back_button();
?>
<div class="main contenido">
<form name="form1" method="post" action="">
<div class="titulo">Modificar Usuario</div>

<table width="100%" border="0" cellspacing="0" cellpadding="0">
<?php if(!$inserted){?>
	<tr class="<?php echo $bgcolor = switchbgcolor($bgcolor);?>">
    	<td colspan="2" class="error tablecontenido"><?php echo $error; ?>&nbsp;</td>
    </tr>
    <tr class="<?php echo $bgcolor = switchbgcolor($bgcolor); ?>">
    	<td class="tablecontenido"><strong>Nombre</strong></td>
        <td class="tablecontenido"><input type="text" name="nombre" id="nombre" value="<?php echo $nombre; ?>" /></td>
    </tr>
   <tr class="<?php echo $bgcolor = switchbgcolor($bgcolor); ?>">
    	<td class="tablecontenido"><strong>Empresa</strong></td>
        <td class="tablecontenido"><input type="text" name="empresa" id="empresa" value="<?php echo $empresa; ?>" /></td>
    </tr> 
    <tr class="<?php echo $bgcolor = switchbgcolor($bgcolor); ?>">
    	<td class="tablecontenido"><strong>Ruc</strong></td>
        <td class="tablecontenido"><input type="text" name="ruc" id="ruc" value="<?php echo $ruc; ?>" /></td>
    </tr> 
  	<tr class="<?php echo $bgcolor = switchbgcolor($bgcolor);?>">
        <td class="tablecontenido"><strong>E-mail</strong></td>
        <td class="tablecontenido"><input type="text" name="email" id="email" value="<?php echo $email; ?>" /></td>
  	</tr>
   <tr class="<?php echo $bgcolor = switchbgcolor($bgcolor);?>">
    	<td class="tablecontenido"><strong>Cliente Magic</strong></td>
        <td class="tablecontenido"><?php $q = "SELECT * FROM ".$DB_MAGIC_CLIENTES."";
        	$q .= " WHERE id NOT IN(SELECT cod_magic FROM ".$DB_USUARIO.""; 
            	if($act == 'mod'){
                	$q .= " WHERE id != ".$id." AND";					
               	}elseif($act == 'add'){
					$q .= " WHERE	";
				}
            $q .= " cod_magic IS NOT NULL ";
            $q .= ") ORDER BY nombre";
	
	
			?>
    	<select name="cod_magic" id="cod_magic"><?php echo createselectitems($mysql->query($q), $cod_magic, 'id', 'nombre'); ?></select></td>
	</tr>
    <tr class="<?php echo $bgcolor = switchbgcolor($bgcolor);?>">
	    <td valign="top" class="tablecontenido"><strong>Status</strong></td>
        <td class="tablecontenido"><select name="status" id="status"><?php echo createselectitems($mysql->query("SELECT * FROM ".$DB_STATUS), $status, 'id', 'nombre');?></select></td>
    </tr>
    <tr class="<?php echo $bgcolor = switchbgcolor($bgcolor);?>">
	    <td class="tablecontenido">&nbsp;</td>
        <td class="tablecontenido"><input name="submit" type="submit" value="Guardar" /></td>
    </tr>
    <?php }else{ ?> 
  <table width="100%" border="0" cellspacing="0" cellpadding="0">
    <tr>
      <td colspan="2" class="tablecontenido">Esta es la informaci&oacute;n del usuario que acaba de crear o modificar, debe cambiar la contrase&ntilde;a la primera vez que ingrese.</td>
    </tr>
    <tr>
      <td class="tablecontenido"><strong>Nombre de Usuario</strong></td>
      <td class="tablecontenido" style="font-size:large;"><strong><?php echo $email; ?></strong></td>
    </tr>
    <tr>
      <td class="tablecontenido"><strong>Contrase&ntilde;a</strong></td>
      <td class="tablecontenido" style="font-size:large;"><strong><?php echo $pass; ?></strong></td>
    </tr>
  </table>
<?php
}
?>

  </table>
</form>
</div>
<?php include_once "includes/bottom.php"; ?>