<?php 
include_once "includes/auth.php";
if (!is_script($script)){
	pretty_die($no_ejecuta);
}
?>
<?php 
//Se inicializan las variables
$inserted = false;
$error = "";
if($act == 'add'){
	$mail = '';
	$apellido = '';
	$nombre = '';
	$user = '';
	$userid = 0;
	$username_id = NULL;
	$secciones = '';
}elseif($act == 'mod'){
	if(isset($_GET['id'])){
		$userid = limpiar_input('id', 'get', 'int');
	}else{
		pretty_die("Debe escoger un administrador para modificar.");
	}
	$strdatos = "SELECT * FROM ".$DB_USERS." WHERE id = ".$userid;
	$datos = mysqli_fetch_array($mysql->query($strdatos));
	$mail = $datos['mail'];
	$apellido = $datos['apellido'];
	$nombre = $datos['nombre'];
	$user = $datos['user'];
	$username_id = $userid;
}
//error Checking
if ($_POST){
	$mail = limpiar_input('mail', 'post', 'string', false);
	$apellido = limpiar_input('apellido', 'post', 'string', false);
	$nombre = limpiar_input('nombre', 'post', 'string', false);
	$user = limpiar_input('user', 'post', 'string', true);
	//E-mail
	if ($mail == ''){
		$error = error('v1', 'e-mail');
	}elseif(!valid_mail($mail)){
		$error = error('v4');
	}
	//Apellido
	if ($apellido == ''){
		$error = error('v1', 'apellido');
	}
	//Nombre
	if ($nombre == ''){
		$error = error('v1', 'nombre');
	}
	//Usuario
	if ($user == ''){
		$error = error('v1', 'nombre de usuario');
	}elseif(user_existe($user, $username_id)){
		$error = error('v3');
	}
	//Ya checkeando todos los errores, si no hay, se escribe en la base de datos.
	if ($error == ''){
		if ($act == 'add'){
			$pass = createPassword(5);
			$strinsert = "INSERT INTO ".$DB_USERS." (id, user, password, nombre, apellido, mail, timestamp, cambiarpassword) VALUES ('','".$user."','".md5_salt($pass)."','".$nombre."','".$apellido."', '".$mail."','0', '1')";
			$cambio = "Agreg&oacute; al administrador <strong>".$user."</strong>";
		}
		if ($act == 'mod'){
			$strinsert = "UPDATE ".$DB_USERS." SET user = '".$user."', nombre = '".$nombre."', apellido = '".$apellido."', mail = '".$mail."' WHERE id = ".$userid;
			$cambio = "Modific&oacute; al administrador <strong>".$user."</strong>";
		}
		//echo $strinsert;
		if($mysql->query($strinsert)){
			if($act == 'add'){
				$userid = last_inserted_id();
			}
			//Modificar los permisos del usuario
			$results_permisos = $mysql->query("SELECT * FROM ".$DB_PERMISOS);
			$control = false;
			while($array_permisos = mysqli_fetch_array($results_permisos)){
				if(isset($_POST['permisos'.$array_permisos['id']]) and $_POST['permisos'.$array_permisos['id']] == 'on'){
					$control = true;
				}else{
					$control = false;
				}
				cambiar_permiso_user($userid, $array_permisos['id'], $control);
			}
			agregarbitacora($main_modulo, $cambio);
			if($act == 'add'){
				$inserted = true;
			}else{
				echo redirect("back.php");
			}
		}else{
			$error = error('db1')." ".$strinsert;
		}
	}
}
?>
<?php 
	include_once "includes/top.php";
	echo back_button();
?>
<div class="main contenido">
<?php
if (!$inserted){ 
?>
<form name="form1" method="post" action="">
<div class="titulo"><?php  if($act == 'add'){?>Crear Administrador<?php  }elseif($act == 'mod'){?>Modificar Administrador<?php  } ?></div>
  <table width="100%" border="0" cellspacing="0" cellpadding="0">
      <col width="150" />
      <col />
    <tr>
      <td colspan="2" class="error"><?php  echo $error; ?>&nbsp;</td>
    </tr>
    <tr class="<?php  echo $bgcolor = switchbgcolor($bgcolor);?>">
      <td class="tablecontenido"><strong>Nombre de Usuario</strong></td>
      <td><input name="user" type="text" id="user" style="width:220px;" value="<?php  echo $user; ?>" autocomplete="off" /></td>
    </tr>
    <tr class="<?php  echo $bgcolor = switchbgcolor($bgcolor);?>">
      <td class="tablecontenido"><strong>Nombre</strong></td>
      <td><input name="nombre" type="text" value="<?php  echo $nombre; ?>" style="width:220px;" autocomplete="off" /></td>
    </tr>
    <tr class="<?php  echo $bgcolor = switchbgcolor($bgcolor);?>">
      <td class="tablecontenido"><strong>Apellido</strong></td>
      <td><input name="apellido" type="text" value="<?php  echo $apellido; ?>" style="width:220px;" autocomplete="off" /></td>
    </tr>
    <tr class="<?php  echo $bgcolor = switchbgcolor($bgcolor);?>">
      <td class="tablecontenido"><strong>e-mail</strong></td>
      <td><input name="mail" type="text" id="mail" style="width:220px;" value="<?php  echo $mail; ?>" autocomplete="off" /></td>
    </tr>
    <tr class="<?php  echo $bgcolor = switchbgcolor($bgcolor);?>">
      <td valign="top" class="tablecontenido"><strong>Permisos</strong></td>
      <td>
      <?php  
		$q_grupo = "SELECT * FROM ".$DB_MENU_GRUPO." ORDER BY orden ASC";
		$result_grupo = $mysql->query($q_grupo);
		$cont = 0;
		if(mysqli_num_rows($result_grupo) > 0){
			while($array_grupo = mysqli_fetch_array($result_grupo)){
				echo '<div class="grupo_permiso"><div class="titulo">'.htmlentities($array_grupo['nombre']).'</div>';
				$results_sec = $mysql->query("SELECT * FROM ".$DB_PERMISOS." WHERE grupo = ".$array_grupo['id']." ORDER BY orden ASC");
				if(mysqli_num_rows($results_sec) > 0){
					echo '<table width="100%" border="0" cellspacing="0" cellpadding="0">';
					while($array_permisos = mysqli_fetch_array($results_sec)){
						?><tr class="<?php  echo $bgcolor = switchbgcolor($bgcolor);  ?>">
						<td class="tablecontenido">
							<label><input type="checkbox" name="permisos<?php  echo $array_permisos['id']; ?>" id="permisos<?php  echo $array_permisos['id']; ?>" <?php  if( ($_POST and isset($_POST['permisos'.$array_permisos['id']])) or (!$_POST and tiene_permiso($array_permisos['id'], $userid)) ){ ?>checked="checked"<?php  } ?> /><?php  echo $array_permisos['descripcion']; ?></label></td>
					  </tr> 
					   <?php  
					}
					echo '</table>'; 
				}
				echo '</div>';
				$cont++;
				if($cont%3 == 0){
					echo '<div class="clear"></div>';
				}
			}
		}
		?>
    </table></td>
    </tr>
    <tr class="<?php  echo $bgcolor = switchbgcolor($bgcolor);?>">
      <td>&nbsp;</td>
      <td><input name="submit" type="submit" value="Guardar" /></td>
    </tr>
  </table>
</form>
<?php 
}else{
?>
<div class="titulo"><?php if($act == 'add'){?>Crear Administrador<?php }elseif($act == 'mod'){?>Modificar Administrador<?php } ?></div>
  <table width="100%" border="0" cellspacing="0" cellpadding="0">
      <col width="100" />
      <col />
    <tr>
      <td colspan="2" class="tablecontenido">Esta es la informaci&oacute;n del usuario que acaba de crear o modificar, debe cambiar la contrase&ntilde;a la primera vez que ingrese.</td>
    </tr>
    <tr>
      <td colspan="2" height="10"></td>
    </tr>
    <tr>
      <td class="tablecontenido"><strong>Nombre de Usuario</strong></td>
      <td class="tablecontenido" style="font-size:large;"><strong><?php echo $user; ?></strong></td>
    </tr>
    <tr>
      <td class="tablecontenido"><strong>Contrase&ntilde;a</strong></td>
      <td class="tablecontenido" style="font-size:large;"><strong><?php echo $pass; ?></strong></td>
    </tr>
    <tr>
      <td colspan="2" align="center"><a href="javascript:print()" class="print"><img src="images/sistema/icon_print.jpg" alt="Imprimir" border="0" /><br />
Imprimir</a></td>
  </tr>
  </table>
<?php
}
?>
</div>
<?php 
include_once "includes/bottom.php";
?>