<?php 
include_once "includes/auth.php";
include_once "includes/top.php";
?>
<?php  
if (!tiene_permiso(2, $_SESSION['userid'])){
	pretty_die($no_permiso);
}
?>
<?php 
$script = "huellas.php";
$error = '';
//Filtro de usuario
if(isset($_GET['f_user'])){
	$f_user = limpiar_input('f_user', 'get', 'int');
}else{
	$f_user = 0;
}
//Filtro de seccion
if(isset($_GET['f_seccion'])){
	$f_seccion = limpiar_input('f_seccion', 'get', 'string', true);
}else{
	$f_seccion = 'noopcion';
}
//Filtro de Descripcion
if(isset($_GET['f_descripcion'])){
	$f_descripcion = limpiar_input('f_descripcion', 'get', 'string', true);
}else{
	$f_descripcion = '';
}
//Filtro de fecha inicial
if(isset($_GET['f_fecha_ini']) and $_GET['f_fecha_ini'] != ''){
	$f_fecha_ini = limpiar_input('f_fecha_ini', 'get', 'string', false);
	$fecha_array = explode("/", $f_fecha_ini);
	$f_fecha_ini = mktime(0, 0, 0, $fecha_array[1], $fecha_array[0], $fecha_array[2]);//Se formatea la fecha
	$f_fecha_ini_show = format_fecha($f_fecha_ini);
}else{
	$f_fecha_ini = '';
	$f_fecha_ini_show = '';
}
//Filtro de fecha final
if(isset($_GET['f_fecha_fin']) and $_GET['f_fecha_fin'] != ''){
	$f_fecha_fin = limpiar_input('f_fecha_fin', 'get', 'string', false);
	$fecha_array = explode("/", $f_fecha_fin);
	$f_fecha_fin = mktime(0, 0, 0, $fecha_array[1], $fecha_array[0], $fecha_array[2]);//Se formatea la fecha
	$f_fecha_fin_show = format_fecha($f_fecha_fin);
}else{
	$f_fecha_fin = '';
	$f_fecha_fin_show = '';
}
$bitacoraq = "SELECT * FROM ".$DB_HUELLAS;

//Se toman todos los filtros y se aplican al query
$where = false;
//Variable filtrable descripcion
if($f_descripcion != ''){
	if (!$where){
		$bitacoraq .= " WHERE ";
		$where = true;
	}else{
		$bitacoraq .= "AND ";
	}
	$bitacoraq .= " cambio LIKE '%".$f_descripcion."%' ";	
}
//Variable filtrable nombre de usuario
if($f_seccion != 'noopcion'){
	if (!$where){
		$bitacoraq .= " WHERE ";
		$where = true; 
	}else{
		$bitacoraq .= "AND ";
	}
	$bitacoraq .= " modulo LIKE '".$f_seccion."' ";	
}
//Variable filtrable nombre de usuario
if($f_user !=  0){
	if (!$where){
		$bitacoraq .= " WHERE ";
		$where = true;
	}else{
		$bitacoraq .= "AND ";
	}
	$bitacoraq .= " userid = ".$f_user." ";	
}
//Variables filtrables de fecha
if ($f_fecha_ini != '' and $f_fecha_fin != '' and $f_fecha_fin < $f_fecha_ini){
	$error = "La fecha inicial es mayor que la fecha final, por favor corr&iacute;jalo.";
	$f_fecha_fin = '';
}
//Luego de hacer todas las verificaciones en las fechas se procede a filtrar los datos por fechas.
if ($f_fecha_ini != ''){
	if (!$where){
		$bitacoraq .= " WHERE ";
		$where = true;
	}else{
		$bitacoraq .= " AND ";
	}
	$bitacoraq .= " fecha >= ".$f_fecha_ini." ";	
}
if ($f_fecha_fin != ''){
	if (!$where){
		$bitacoraq .= " WHERE ";
		$where = true;
	}else{
		$bitacoraq .= " AND ";
	}
	$bitacoraq .= " fecha <= ".$f_fecha_fin." ";	
}
//Se inicializa el control por paginas
if(!isset($_GET['page'])){
	$page = 1;
}else{
	$page = limpiar_input('page', 'get',  'int');
}
//Se inicializan los ordenadores
if (!isset($_GET['orderby'])){
	$orderby = 'fecha';
}else{
	$orderby = limpiar_input('orderby', 'get',  'string', true);
}
if (!isset($_GET['orderdir'])){
	$orderdir = 'DESC';
}else{
	$orderdir = limpiar_input('orderdir', 'get',  'string', true);
}
$bitacoraq .= " ORDER BY ".$orderby." ".$orderdir;
$limit = ($page * $paging) - $paging;	
$bitacoraq_limit = $bitacoraq." LIMIT ".$limit." , ".$paging;
//echo $bitacoraq;
$bitacora = $mysql->query($bitacoraq_limit);
$cantpaginas = ceil(mysqli_num_rows($mysql->query($bitacoraq))/$paging);
?>
<?php  
echo back_button();
?>
<div class="main contenido">
<div class="titulo">Huellas del Sistema</div>
<form action="" method="get" name="filtro">
<table cellpadding="0" cellspacing="0" border="0" width="100%" class="filtro">
  <tr>
    <td colspan="6" class="error"><?php  echo $error; ?>&nbsp;</td>
  </tr>
  <tr>
    <td>Usuario</td>
    <td>M&oacute;dulo</td>
    <td>Descripcion</td>
    <td>Fecha Inicial</td>
    <td>Fecha Final</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td><select name="f_user" id="f_user" style="width:100px;" onchange="submit();"><?php 
		echo createselectitems($mysql->query("SELECT DISTINCT ".$DB_HUELLAS.".userid, ".$DB_USERS.".user FROM ".$DB_HUELLAS.", ".$DB_USERS." WHERE ".$DB_HUELLAS.".userid = ".$DB_USERS.".id"), $f_user, "userid", "user", true); 		?></select></td>
    <td><select name="f_seccion" id="f_seccion" style="width:150px;" onchange="submit();"><?php 
		echo createselectitems($mysql->query("SELECT DISTINCT modulo FROM ".$DB_HUELLAS), $f_seccion, "modulo", "modulo", true); 
		?></select></td>
    <td><input type="text" name="f_descripcion" id="f_descripcion" style="width:130px;" value="<?php  echo $f_descripcion; ?>" /></td>
    <td><input type="text" name="f_fecha_ini" id="f_fecha_ini" style="width:70px;" value="<?php  echo $f_fecha_ini_show; ?>" readonly="readonly" /> <input type="button" value="&nbsp;" onclick="displayCalendar(document.getElementById('f_fecha_ini'),'dd/mm/yyyy',this)" class="calendar" /></td>
    <td><input type="text" name="f_fecha_fin" id="f_fecha_fin" style="width:70px;" value="<?php  echo $f_fecha_fin_show; ?>" readonly="readonly" /> <input type="button" value="&nbsp;" onclick="displayCalendar(document.getElementById('f_fecha_fin'),'dd/mm/yyyy',this)" class="calendar" /></td>
    <td><input type="submit" name="button" id="button" value="Filtrar" /></td>
  </tr>
</table>
</form>
<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr class="toptable toptableseparador">
    <td><?php  echo creartituloordenador("Fecha", "fecha", $orderby, $orderdir, $script, remarraysendtoget($_GET, 'orderby-*-orderdir-*-page')); ?></td>
    <td><?php  echo creartituloordenador("Usuario", "userid", $orderby, $orderdir, $script, remarraysendtoget($_GET, 'orderby-*-orderdir-*-page')); ?></td>
    <td><?php  echo creartituloordenador("M&oacute;dulo", "modulo", $orderby, $orderdir, $script, remarraysendtoget($_GET, 'orderby-*-orderdir-*-page')); ?></td>
    <td>Cambio</td>
    <td>IP</td>
  </tr>
<?php 
while ($bitacoradata = mysqli_fetch_array($bitacora)){
$bgcolor = switchbgcolor($bgcolor);
?>
  <tr class="<?php  echo $bgcolor?>">
    <td class="tablecontenido"><?php  echo date("j/m/Y g:i a", $bitacoradata['fecha']); ?></td>
    <td class="tablecontenido"><?php  echo nombre_tabla($bitacoradata['userid'], $DB_USERS, 'user'); ?></td>
    <td class="tablecontenido"><?php  
	if(strstr($bitacoradata['modulo'], '.php')){ 
		echo '<a href="'.$bitacoradata['modulo'].'">';
	}
	echo $bitacoradata['modulo']; 
	if(strstr($bitacoradata['modulo'], '.php')){ 
		echo '</a>';
	}
	?></td>
    <td class="tablecontenido"><?php  echo $bitacoradata['cambio']; ?></td>
    <td class="tablecontenido"><?php  echo $bitacoradata['ip']; ?></td>
  </tr>
<?php 
}
if (mysqli_num_rows($bitacora) < 1){
?>
<tr class="<?php  echo $bgcolor?>">
    <td class="tablecontenido" colspan="5">No hay elementos para mostrar.</td>
  </tr>
<?php 
}
?>
</table>
<?php  
echo paging($script, $page, $cantpaginas, remarraysendtoget($_GET, 'page'));
?>
</div>
<?php 
//Termina el contenido de la pagina
include_once "includes/bottom.php";
?>
